
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tap.h"
#include "DirScan.h"

#define MAX_FILE_COUNT		256
#define MAX_FOLDER_COUNT	64

tDirScan	dsc;
tFile		files[MAX_FILE_COUNT];
tFolder		folders[MAX_FOLDER_COUNT];

//

void ChangeToRoot()
{
	TYPE_File file;
	word count = 0;
	TAP_Hdd_FindFirst(&file);
	while (file.name[0] == '.' && count < 16) {
		if (TAP_Hdd_ChangeDir("..") == 0) break;
		count++;
		TAP_Hdd_FindFirst(&file);
	}
}

//

bool ChangeToData()
{
	TYPE_File file;
	word count = 0;
	TAP_Hdd_FindFirst(&file);
	while (file.startCluster != dsc.dataCluster && file.startCluster != dsc.rootCluster && count++ < 16) {
		TAP_Hdd_ChangeDir("..");
		TAP_Hdd_FindFirst(&file);
	}
	if (file.startCluster == dsc.dataCluster) return TRUE;
	if (file.startCluster == dsc.rootCluster) {
		TAP_Hdd_ChangeDir("DataFiles");
		return TRUE;
	}
	return FALSE;
}

//

int DSFindParent( dword parentCluster )
{
	int i;
	for (i=0; i<dsc.folderCount; i++)
		if (parentCluster == folders[i].startCluster) return i;
	return -1;
}

//

void DSChangeDir( int index )
{
	int pathCount;
	int path[16];		// 16 Verzeichnis Ebenen
	dword currCluster;
	TYPE_File file;

	TAP_Hdd_FindFirst(&file);
	currCluster = file.startCluster;
	if (currCluster == folders[index].startCluster)
		return;		//passt schon
	if (index == 0) {
		ChangeToData();
		return;
	}
	pathCount=1;
	path[0]=index;
	do {
		index = DSFindParent(folders[index].parentCluster);
		if (index > 0) {
			path[pathCount] = index;
			pathCount++;
		}
	} while (pathCount < 16 && index > 0);
	ChangeToData();
	while (pathCount > 0) {
		pathCount--;
		index = path[pathCount];
		TAP_Hdd_ChangeDir(folders[index].name);
	}
}

//
// aktuelles Verzeichnis nach *.rec durchsuchen
//

int DSDirScan( dword dirStartCluster )
{
	int  i,count;
	char  *dot;
	TYPE_File file;

	count = TAP_Hdd_FindFirst( &file );
	if (count > 256) count = 256;
	for (i=1; i<count; i++) {
		TAP_Hdd_FindNext( &file );
		if (dsc.bScanSubdirs && file.attr == 0xF2) {		//Dir
			folders[dsc.folderCount].startCluster = file.startCluster;
			folders[dsc.folderCount].parentCluster = dirStartCluster;
			if (strlen(file.name) < TS_FILE_NAME_SIZE) {
				strcpy(folders[dsc.folderCount].name, file.name);
				dsc.folderCount++;
			}
			if (dsc.folderCount >= MAX_FOLDER_COUNT) return -1;
		} else if (file.attr == 0xD0 || file.attr == 0xD1) {
			dot = strrchr(file.name, '.');
			if (dot != NULL && dot > file.name) {
				if (stricmp(dot, ".rec") == 0) {
					files[dsc.fileCount].startCluster = file.startCluster;
					files[dsc.fileCount].parentCluster = dirStartCluster;
					files[dsc.fileCount].dateTime = (file.mjd <<16) | (file.hour <<8) | file.min;
					if (strlen(file.name) < TS_FILE_NAME_SIZE) {
						strcpy(files[dsc.fileCount].name, file.name);
						dsc.fileCount++;
					}
					if (dsc.fileCount >= MAX_FILE_COUNT) return -1;
				}
			}
		}
	}
	return 0;
}

//
// DataFiles und alle Unterverzeichnisse nach *.rec durchsuchen
//

int DSFindFiles( bool subdirs )
{
	TYPE_File file;

	memset(&dsc, 0, sizeof(dsc));
	ChangeToRoot();
	TAP_Hdd_FindFirst(&file);
	dsc.rootCluster = file.startCluster;
	TAP_Hdd_ChangeDir("DataFiles");
	TAP_Hdd_FindFirst(&file);
	dsc.dataCluster = file.startCluster;
	dsc.bScanSubdirs = subdirs;
	dsc.folderCount=1;
	folders[0].startCluster = dsc.dataCluster;
	folders[0].parentCluster = dsc.rootCluster;
	do {
		DSChangeDir(dsc.folderIndex);
		if (DSDirScan(folders[dsc.folderIndex++].startCluster) < 0) break;
	} while (dsc.folderIndex < dsc.folderCount);
	return dsc.fileCount;
}

//

tFile * DSGetNextFile()
{
	if (dsc.fileIndex < dsc.fileCount)
		return &files[dsc.fileIndex++];
	return NULL;
}

//

TYPE_File * DSOpenFile( tFile * file )
{
	int index;
	index = DSFindParent(file->parentCluster);
	DSChangeDir(index);
	return TAP_Hdd_Fopen(file->name);
}

void DSSetDirectory( tFile * file )
{
	int index;
	index = DSFindParent(file->parentCluster);
	DSChangeDir(index);
}

