#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tap.h"
#include "HDDIO.h"


typedef struct
{
	bool			bTurbolader;
	TYPE_File		*file;
	dword			sector;
	tTAP_Hdd_ReadSectorDMA  ReadSectorDMA;
} tHdd;

tHdd hdd;
static TYPE_Fileex fpx;
static byte * sectorBuffer;

void Hdd_Init()
{
	byte buffer[512];
	hdd.ReadSectorDMA = (tTAP_Hdd_ReadSectorDMA) TAP_GetSystemProc(oTAP_Hdd_ReadSectorDMA);
	hdd.ReadSectorDMA(0, 1, buffer);
	fpx.SectorsPerCluster = (buffer[0x22] << 8) | buffer[0x23];
}

//

dword Hdd_CalcAbsSectorFromFAT( dword relSector )
{
	dword absCluster,relCluster;

	absCluster = fpx.startCluster;
	if (absCluster > 131071) return 0;

	while (relSector >= fpx.SectorsPerCluster) {
		absCluster = fpx.FAT[absCluster];
		if (absCluster > 131071) return 0;
		relSector -= fpx.SectorsPerCluster;
	}
	return (fpx.SectorsPerCluster * (absCluster+1)+relSector);
}

//

bool Hdd_Fopen( TYPE_File *file, bool turbo )
{
	int i;
	byte *buf;

	hdd.file = file;
	if (hdd.file == NULL) return FALSE;
	if (!turbo || (hdd.file->size>>10) < 4090000) {
		hdd.bTurbolader = FALSE;
		return TRUE;
	}
	hdd.bTurbolader = TRUE;
	memcpy(&fpx, hdd.file, sizeof(TYPE_File));
	buf = ((byte *) fpx.FAT)+131072;
	hdd.ReadSectorDMA( 256, 768, buf );
	for (i=0; i<131072; i++) {
		fpx.FAT[i] = (*buf << 16) | (*(buf+1) << 8) | *(buf+2);
		buf+=3;
	}
	hdd.sector = 0;
	return TRUE;
}

//

dword Hdd_Fread( dword size, byte *buffer )
{
	dword absSector;
	if (!hdd.bTurbolader)
		return TAP_Hdd_Fread(buffer, size, 1, hdd.file);
	sectorBuffer = buffer;
	absSector = Hdd_CalcAbsSectorFromFAT(hdd.sector);
	hdd.ReadSectorDMA (absSector, size>>9, sectorBuffer);
	hdd.sector += size>>9;
	return 0;
}

//

void Hdd_Fclose()
{
	return TAP_Hdd_Fclose(hdd.file);
}

//
// Seek Genauigkeit = 1 Sector = 512 Byte
//

dword Hdd_Fseek( dword position )
{
	if (!hdd.bTurbolader)
		return TAP_Hdd_Fseek(hdd.file, position<<9, SEEK_SET);
	hdd.sector = position;
	return 0;
}

