
#include "tap.h"

//
// Dieser Firmware-Patch modifiziert die API-Funktion TAP_Hdd_Fseek() und
// ermglicht so Datei-Zugriffe bis 4 GB (nur bei SEEK_SET).
// Der BLTZL-Opcode wird bei SEEK_SET bersprungen und dadurch wird 
// TYPE_File.currentPos immer gespeichert, auch bei Werten grer
// als 2 GB. (thanks Harvey)
// Der Patch ist Firmware-unabhngig und funktioniert mit allen Versionen.
// z.B.: Firmware vom 13.09.2005
/*
801455ac:    0080b025   or   $s6,$a0,$zero           # s6 = a0 = TYPE_File
801455b0:    14800003   bne  $a0,$zero,0x801455c0    # if(a0!=0) s5=a1
801455b4:    00a0a825   or   $s5,$a1,$zero           # s5 = a1 = seek_offset
801455b8:    10000016   beq  $zero,$zero,0x80145614  # return (TYPE_File==NULL)
801455bc:    00001025   or   $v0,$zero,$zero         # v0 = 0
801455c0:    50c00009   beql $a2,$zero,0x801455e8    # if(a2==0) fp=s5   <<< vorher  >>>
           ( 50c00012   beql $a2,$zero,0x8014560c )  # (SEEK_SET)        <<< nachher >>>
801455c4:    02a0f025   or   $fp,$s5,$zero
801455c8:    34010001   ori  $at,$zero,0x1           # at = 1 (SEEK_CUR)
801455cc:    50c10008   beql $a2,$at,0x801455f0      # if(a2==at) t9=currentPos
801455d0: *  8c990090   lw   $t9,144($a0)
801455d4:    34010002   ori  $at,$zero,0x2           # at = 2 (SEEK_END)
801455d8:    10c10007   beq  $a2,$at,0x801455f8      # if(a2==at)
801455dc:    00000000   nop
801455e0:    10000008   beq  $zero,$zero,0x80145604  # a2 > 2
801455e4:    00000000   nop
801455e8:    10000006   beq  $zero,$zero,0x80145604  # fp: seek_offset (SEEK_SET)
801455ec:    00000000   nop
801455f0:    10000004   beq  $zero,$zero,0x80145604  # fp: seek_offset+currentPos (SEEK_CUR)
801455f4:    00b9f021   addu $fp,$a1,$t9
801455f8:    0c0515d8   jal  0x80145760              # v1 = file_length (SEEK_END)
801455fc:    00000000   nop
80145600:    0075f021   addu  $fp,$v1,$s5            # fp = v1+seek_offset
80145604: *  07c20003   bltzl $fp,0x80145614         # if(fp<0) return
80145608:    8ec20090   lw  $v0,144($s6)
8014560c: *  aede0090   sw  $fp,144($s6)             # currentPos = fp
80145610:    8ec20090   lw  $v0,144($s6)
80145614:    8fbf0010   lw  $ra,16($sp)
80145618:    8fb50014   lw  $s5,20($sp)
8014561c:    8fb60018   lw  $s6,24($sp)
80145620:    8fbe001c   lw  $fp,28($sp)
80145624:    03e00008   jr  $ra            # opcodes mit "*" gibt's nur 1x in der Firmware
*/
//

bool FileSeekPatch( bool enable )
{
	dword opcode;
	dword * adr;

	adr = (dword *)0x80000000;
	do {
		opcode = *adr;
		if (opcode == 0x8C990090) {					// lw  $t9,144($a0)
			opcode = *(adr+13);
			if (opcode == 0x07C20003) {				// bltzl  $fp,0x80...
				opcode = *(adr+15);
				if (opcode == 0xAEDE0090) {			// sw  $fp,144($s6)
					opcode = *(adr-4);
					if (enable) {					// Fseek-Patch einschalten
						if (opcode == 0x50C00009) {	// beql  $a2,$zero,0x80...
							*(adr-4) = 0x50C00012;
							return TRUE;
						} else if (opcode == 0x50C00012)
							return TRUE;
					} else {						// Fseek-Patch ausschalten
						if (opcode == 0x50C00012) {	// beql  $a2,$zero,0x80...
							*(adr-4) = 0x50C00009;
							return TRUE;
						} else if (opcode == 0x50C00009)
							return TRUE;
					}
				}
			}
		}
		adr++;
	} while (adr < (dword *)0x802DE000);
	return FALSE; //nix gefunden
}


