
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tap.h"
#include "Overfly.h"

extern tIniFile ini;
extern bool bIniFile;
extern byte buffer[1656];

//

int string2int( char *text )
{
	int  value,digit,base,sign;
	bool b;
	char ch;
	value = 0;
	base = 10;
	sign = 1;
	if (*text == '-') {
		text++;
		sign = -1;
	}
	if (*text == '0' && *(text+1) == 'x') {	//Hexadezimal
		base = 16;
		text+=2;
	}
	do {
		ch = *text++;
		digit = (int)(ch-'0');
		if (base == 10) {
			b = ch >= '0' && ch <= '9';
		} else {
			b = (ch >= '0' && ch <= '9') || (ch >= 'a' && ch <= 'f') ||
				(ch >= 'A' && ch <= 'F');
			if (digit > 9) digit = (digit & 0x0F)+9;
		}
		if (b) value = value*base + digit;
	} while (b);
	return value*sign;
}

//

int GetIniParam( char *name )
{
	char *pos;
	char param[32];
	TAP_SPrint(param, "\n%s=", name);
	pos = strstr(buffer, param);
	if (pos == NULL) return 0xCAFEBABE;
	pos += strlen(param);
	return string2int(pos);
}

//

int ReadIniFile()
{
	TYPE_File *file;
	ini.bPatch20 = FALSE;
	ini.bPatch51 = FALSE;
	ini.bBookmarkS = FALSE;
	ini.bBookmarkE = TRUE;
	ini.bBMImport = FALSE;
	ini.bFilmList = TRUE;
	ini.bAviator = TRUE;
	ini.bReload = TRUE;
	ini.bPatchFseek = TRUE;
	ini.bTurbolader = FALSE;
	ini.bPatchEPG = FALSE;
	ini.bRename = FALSE;
	ini.bSubdirs = FALSE;
	ini.bBlackbox = FALSE;
	ini.bLetterbox = FALSE;
	ini.countdownX = 40;
	ini.countdownY = 30;
	ini.menuKey = 0x10025; //Goto
	ini.jumpDelay = 30;
	ini.volume = 2;
	ini.dejavue = -15;
	ini.autoStart = 15;
	ini.seekStep = 64;
	ChangeToRoot();
	TAP_Hdd_ChangeDir("ProgramFiles");
	if (!TAP_Hdd_Exist(INI_FILE)) return -1;
	file = TAP_Hdd_Fopen(INI_FILE);
	if (file == NULL) return -2;
	TAP_Hdd_Fread(buffer, 1024, 1, file);
	TAP_Hdd_Fclose(file);
	if (GetIniParam("PatchDD2.0") == 1) ini.bPatch20 = TRUE;
	if (GetIniParam("PatchDD5.1") == 1) ini.bPatch51 = TRUE;
	if (GetIniParam("BookmarkS") == 1) ini.bBookmarkS = TRUE;
	if (GetIniParam("Bookmarks") == 0) ini.bBookmarkE = FALSE;
	if (GetIniParam("BookmarkE") == 0) ini.bBookmarkE = FALSE;
	if (GetIniParam("BMImport") == 1) ini.bBMImport = TRUE;
	if (GetIniParam("FilmList") == 0) ini.bFilmList = FALSE;
	if (GetIniParam("Aviator") == 0) ini.bAviator = FALSE;
	if (GetIniParam("Reload") == 0) ini.bReload = FALSE;
	if (GetIniParam("PatchFseek") == 0) ini.bPatchFseek = FALSE;
	if (GetIniParam("Turbolader") == 1) ini.bTurbolader = TRUE;
	if (GetIniParam("PatchEPG") == 1) ini.bPatchEPG = TRUE;
	if (GetIniParam("Rename") == 1) ini.bRename = TRUE;
	if (GetIniParam("Subdirs") == 1) ini.bSubdirs = TRUE;
	if (GetIniParam("Blackbox") == 1) ini.bBlackbox = TRUE;
	if (GetIniParam("Letterbox") == 1) ini.bLetterbox = TRUE;
	ini.countdownX = GetIniParam("CountdownX");
	if (ini.countdownX > 680) ini.countdownX = 40;
	ini.countdownY = GetIniParam("CountdownY");
	if (ini.countdownY > 550) ini.countdownY = 30;
	ini.jumpDelay = GetIniParam("Delay");
	if (ini.jumpDelay > 50) ini.jumpDelay = 50;
	ini.volume = GetIniParam("Volume");
	if (ini.volume > 17) ini.volume = 17;
	ini.dejavue = GetIniParam("DejaVue");
	if (ini.dejavue < -50) ini.dejavue = -50;
	if (ini.dejavue > 300) ini.dejavue = 300;
	ini.menuKey = GetIniParam("MenuKey");
	if (ini.menuKey < 0x10000 || ini.menuKey > 0x10050) ini.menuKey = 0x10025; //Goto
	ini.autoStart = GetIniParam("AutoStart");
	if (ini.autoStart > 600) ini.autoStart = 600; //=10 Minuten
	ini.seekStep = GetIniParam("SeekStep");
	if (ini.seekStep < 16) ini.seekStep = 16;
	if (ini.seekStep > 128) ini.seekStep = 128;
	return 0;
}

//

void SetIniParam( char *pname, int value )
{
	char temp[64];
	TAP_SPrint(temp, "%s=%d\r\n", pname, value);
	strcpy((char *)buffer+ini.fpos, temp);
	ini.fpos += strlen(temp);
	buffer[ini.fpos] = 32;
}

int WriteIniFile()
{
	TYPE_File *file;
	ChangeToRoot();
	TAP_Hdd_ChangeDir("ProgramFiles");
	if (!TAP_Hdd_Exist(INI_FILE))
		TAP_Hdd_Create(INI_FILE, ATTR_NORMAL);
	file = TAP_Hdd_Fopen(INI_FILE);
	if (file == NULL) return -1;
	memset(buffer, 32, 1024);
	ini.fpos=11;
	strcpy(buffer, "[Overfly]\r\n");
	SetIniParam("PatchDD2.0", ini.bPatch20);
	SetIniParam("PatchDD5.1", ini.bPatch51);
	SetIniParam("BookmarkS", ini.bBookmarkS);
	SetIniParam("BookmarkE", ini.bBookmarkE);
	SetIniParam("BMImport", ini.bBMImport);
	SetIniParam("FilmList", ini.bFilmList);
	SetIniParam("Aviator", ini.bAviator);
	SetIniParam("Reload", ini.bReload);
	SetIniParam("PatchFseek", ini.bPatchFseek);
	SetIniParam("PatchEPG", ini.bPatchEPG);
	SetIniParam("Turbolader", ini.bTurbolader);
	SetIniParam("Rename", ini.bRename);
	SetIniParam("Subdirs", ini.bSubdirs);
	SetIniParam("Blackbox", ini.bBlackbox);
	SetIniParam("Letterbox", ini.bLetterbox);
	SetIniParam("CountdownX", ini.countdownX);
	SetIniParam("CountdownY", ini.countdownY);
	SetIniParam("Delay", ini.jumpDelay);
	SetIniParam("Volume", ini.volume);
	SetIniParam("DejaVue", ini.dejavue);
	SetIniParam("MenuKey", ini.menuKey);
	SetIniParam("AutoStart", ini.autoStart);
	SetIniParam("SeekStep", ini.seekStep);
	TAP_Hdd_Fwrite(buffer, 1024, 1, file);
	TAP_Hdd_Fclose(file);
	if (ini.bPatchFseek)
		ini.bPatchFseek = FileSeekPatch(TRUE);
	else
		FileSeekPatch(FALSE);
	bIniFile = TRUE;
	return 0;
}

