
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tap.h"

#define	LOG_FILE		"Overfly.log"
#define LOG_SIZE		0x30000

char *	logBuffer;
int		logLength;


int LogFileText( char *text )
{
	int len;
	len = strlen(text);
	if (logLength+len+2 >= LOG_SIZE) return -1;
	strcpy(logBuffer+logLength, text);
	logLength += len;
	strcpy(logBuffer+logLength, "\r\n");
	logLength += 2;
	return 0;
}

int LogFileInt( char *format, int number )
{
	char logTemp[128];
	TAP_SPrint(logTemp, format, number);
	LogFileText(logTemp);
	return 0;
}

int LogFileInt2( char *format, int num1, int num2 )
{
	char logTemp[128];
	TAP_SPrint(logTemp, format, num1, num2);
	LogFileText(logTemp);
	return 0;
}

int LogFileInt3( char *format, int num1, int num2, int num3 )
{
	char logTemp[128];
	TAP_SPrint(logTemp, format, num1, num2, num3);
	LogFileText(logTemp);
	return 0;
}

int LogFilePercent( char *text, int pos1, int pos2, int len )
{
	char logTemp[128];
	int  c1,c2;
	if (len == 0) return -1;
	c1 = (pos1*10000)/len;
	c2 = (pos2*10000)/len;
	TAP_SPrint(logTemp, "%s %d.%02d%% - %d.%02d%%  (%d - %d)", text, c1/100, c1%100, c2/100, c2%100, pos1, pos2);
	LogFileText(logTemp);
	return 0;
}

int LogFileDateTime( char *text )
{
	word mjd,year;
	byte hour,min,sec,month,day,weekDay;
	char logTemp[128];

	TAP_GetTime(&mjd, &hour, &min, &sec);
	TAP_ExtractMjd(mjd, &year, &month, &day, &weekDay);
	TAP_SPrint(logTemp, "[%02d.%02d.%d %02d:%02d:%02d] %s", day,month,year, hour,min,sec, text);
	LogFileText(logTemp);
	return 0;
}

//

int LogFileInit()
{
	logLength = 0;
	logBuffer = TAP_MemAlloc(LOG_SIZE);
	if (logBuffer == 0) return -1;
	memset(logBuffer, 32, LOG_SIZE);
	LogFileDateTime("Start");
	return 0;
}

//

void LogFileDelete()
{
	ChangeToRoot();
	TAP_Hdd_ChangeDir("ProgramFiles");
	if (TAP_Hdd_Exist(LOG_FILE))
		TAP_Hdd_Delete(LOG_FILE);
}

//

int LogFileSave()
{
	TYPE_File *file;
	LogFileDelete();
	TAP_Hdd_Create(LOG_FILE, ATTR_NORMAL);
	file = TAP_Hdd_Fopen(LOG_FILE);
	if (file == NULL) return -1;
	LogFileDateTime("Ende\r\n\r\n");
	logLength = (logLength+511) & (LOG_SIZE-512);
	TAP_Hdd_Fwrite(logBuffer, logLength, 1, file);
	TAP_Hdd_Fclose(file);
	if (logBuffer) TAP_MemFree(logBuffer);
	return 0;
}


