
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tap.h"
#include "Pids.h"
#include "FilmList.h"
#include "Overfly.h"
#include "Dialog.h"
#include "FileSeek.h"
#include "DirScan.h"
#include "LogFile.h"
#include "Letterbox.h"
#include "IniFile.h"
#include "Drive.h"

TAP_ID( 0x80270308 );
TAP_PROGRAM_NAME("Overfly");
TAP_AUTHOR_NAME("t3xi");
TAP_DESCRIPTION("Overfly 0.64");
TAP_ETCINFO(__DATE__);

#include "TSRCommander.inc"

tPatch			patch;
tIniFile		ini;
tFile *			pFile;
tBookmarks		bookmarks;
tAdvertising	werbung;
word			sysID;
dword			startTick;
dword			idleTick;
byte			buffer[1656];
bool			bInitialized;
bool			bFindFiles;
bool			bNextStep;
bool			bVolume;
bool			bDialog;
bool			bIniFile;
bool			bResetAudioPids;
bool			bResetBookmarks;
int				currVolume;
int				rECo;
int				countdown;
dword			menuKeyCount;
dword			menuKeyTicks;
byte *			osdBoxData;
TYPE_PlayInfo	playInfo[2];
TYPE_RecInfo	recInfo;


//
// Umschaltung zwischen DD2.0 und DD5.1 suchen
// Liefert Blocknummer zurck
//

dword FilmFinder()
{
	word  leftMode,rightMode,mode,count;
	dword size,offset,left,right,step,block;

	size = (dword)(patch.file->size >> 9);	//sectors
	if (!ini.bTurbolader) {
		if (ini.bPatchFseek) {
			if (size > 4088<<11) size = 4088<<11;
		} else {
			if (size > 2040<<11) size = 2040<<11;
		}
	}
	if (patch.filePos < 8) patch.filePos = 8;
	Hdd_Fseek(patch.filePos);
	leftMode = PidsFindArea51();	// 2.0 oder 5.1
	if (patch.filePos == 8 && leftMode == 0x51)
		step = SMALL_STEP; // kurze Pause zwischen zwei 5.1 Filmen suchen
	else
		step = ini.seekStep<<11;
	offset = patch.filePos;		//sectors
	do {										// skippen bis sich
		offset += step;							// AC3 Mode ndert
		if (step == SMALL_STEP && offset > 160<<11)
			step = ini.seekStep<<11;
		if (offset < size) {
			Hdd_Fseek(offset);
			rightMode = PidsFindArea51();
		}
	} while (leftMode == rightMode && offset < size);
	if (rightMode == 0 || offset > size)
		return 0;
	left = offset-step;							// [leftMode..
	right = offset;								// ..rightMode]
	do {										// Umschaltung suchen
		offset = (left>>1)+(right>>1);
		Hdd_Fseek(offset);
		mode = PidsFindArea51();
		if (mode == leftMode)
			left = offset;
		else
			right = offset;
		step >>= 1;								// Intervallhalbierung
	} while (mode != 0 && step > 256);
	if (mode == 0)
		return 0;
	if (leftMode == 0x20)
		offset = left;
	else
		offset = right;
	patch.filePos = right;
	block = offset/188;		// 1 block = 188 sectors
	if (ini.bBlackbox) {
		LogFileInt3("Block = %d, %X -> %X", block, leftMode, rightMode);
	}
	if (block > 0) {
		if (patch.blockCount == 0) {
			patch.blocks[0] = block;
			patch.modes[0] = rightMode;
			patch.blockCount++;
		} else {
			if (patch.blockCount > 19) return 0;
			if (block > patch.blocks[patch.blockCount-1]+30) {
				patch.blocks[patch.blockCount] = block;
				patch.modes[patch.blockCount] = rightMode;
				patch.blockCount++;
			} else {					//kurze Modewechsel ignorieren
				patch.blocks[patch.blockCount-1] = block;
				patch.modes[patch.blockCount-1] = rightMode;
			}
		}
	}
	return block;
}

//

void DrawCountdown( int count )
{
	word rgn;
	word * pw;
	int x,y,w,h,i;
	dword tick;
	char msg[8];
	TYPE_OsdBaseInfo osdBaseInfo;
	static int lastCount = -1;
	static dword cdtick = 0;

	if (ini.countdownX == 0 || ini.countdownY == 0) return;
	tick = TAP_GetTick();
	if (count == lastCount && tick < cdtick+200) return;
	lastCount = count;
	cdtick = tick;
	x = ini.countdownX;
	y = ini.countdownY;
	w = 64; h = 24;
	TAP_Osd_GetBaseInfo( &osdBaseInfo );
	pw = osdBaseInfo.eAddr+(720*(y+24))+(x*2);
	for (i=x; i<x+w; i+=4) {
		if (*pw != 0) return;
		pw+=4;
	}
	rgn=0;
	if (count == 0)
		TAP_Osd_FillBox(rgn, x, y, w, h, COLOR_None);
	else {
		TAP_SPrint(msg, "OF %d", count);
		TAP_Osd_FillBox(rgn, x, y, w, h, COLOR_None);
		TAP_Osd_PutS(rgn, x+2, y+2, x+w, msg, RGB(1,1,1), COLOR_None, 0, FNT_Size_1622, 0, ALIGN_LEFT);
		TAP_Osd_PutS(rgn, x, y, x+w, msg,  RGB(31,31,31), COLOR_None, 0, FNT_Size_1622, 0, ALIGN_LEFT);
	}
}

//

int GetAC3Pid()
{
	if (ini.bBlackbox) LogFileDateTime(pFile->name);
	if (ini.bFilmList) {
		if (FilmListExists(pFile) >= 0)
			return -1;
	}
	patch.file = DSOpenFile(pFile);
	if (patch.file == NULL) {
		if (ini.bBlackbox) LogFileText("kein Zugriff");
		return -1;
	}
	patch.totalBlocks = ((dword)(patch.file->size >> 11))/47;
	if (!ini.bTurbolader && patch.totalBlocks > 44000) patch.totalBlocks = 44000;
	strcpy(patch.oldName, patch.file->name);
	Hdd_Fopen(patch.file, ini.bTurbolader);
	TAP_Hdd_Fread(buffer, 1656, 1, patch.file);
	patch.ac3Pid = PidsFinder(TRUE);
	if (patch.ac3Pid == 0) {
		if (!ini.bLetterbox) {
			FilmListAddFilm(pFile);
			TAP_Hdd_Fclose(patch.file);
			return -1;
		}
	} else {
		if (ini.bBlackbox) LogFileInt("AC3 PID = %d", patch.ac3Pid);
	}
	patch.freeTV = PidsIsFreeTV();
	return patch.ac3Pid;
}

//

int GetAC3Mode( dword offset )
{
	word mode,slen;
	if ((patch.file->size >> 8) > (offset>>8)+(1<<12)) {
		Hdd_Fseek(offset>>9);
		mode = PidsFindArea51();
		if (ini.bBlackbox)
			LogFileInt2("DD %X @ %d MB", mode, offset>>20);
		if (mode > patch.ac3Mode) patch.ac3Mode = mode;
		if (offset == TS_START) patch.startMode = mode;
	}
	return 0;
}

//

int PatchAudioPid()
{
	if ((ini.bPatch20 && patch.ac3Mode == 0x20) ||
		(ini.bPatch51 && patch.ac3Mode == 0x51)) {
		// AC3 PID in den Record Header schreiben
		buffer[26] = (byte)(0x20 | (patch.ac3Pid>>8));
		buffer[27] = (byte)(patch.ac3Pid & 255);
		if (ini.bBlackbox) {
			if (patch.ac3Mode == 0x20)
				LogFileText("Dolby Digital 2.0");
			else
				LogFileText("Dolby Digital 5.1");
		}
		patch.patched = TRUE;
	} else {
		patch.patched = FALSE;
	}
	return 0;
}

//
// Tonspuren von allen RECs im DataFiles Ordner von AC3 auf MP2 zurcksetzen.
// Aufnahmen in Unterverzeichnissen werden nicht gendert. (1 pro Idle-Evt)
//

bool ResetAudioPids()
{
	word pid;
	tFile * tf;
	TYPE_File * file;

	tf = DSGetNextFile();
	if (tf == NULL) return FALSE;
	file = DSOpenFile(tf);
	if (file != NULL) {
		Hdd_Fopen(file, FALSE);
		TAP_Hdd_Fread(buffer, 28, 1, file);
		if ((buffer[26] & 0x20) == 0x20) {
			PidsFinder(TRUE);
			pid = PidsGetAudioPid(0);
			buffer[26] = (byte)(0x80 | (pid>>8));
			buffer[27] = (byte)(pid & 255);
			TAP_Hdd_Fseek(file, 0, SEEK_SET);
			TAP_Hdd_Fwrite(buffer, 28, 1, file);
		}
		TAP_Hdd_Fclose(file);
	}
	return TRUE;
}

//
// Alle Bookmarks in allen RECs im DataFiles Ordner lschen.
// Bookmarks in Unterverzeichnissen bleiben erhalten. (1 pro Idle-Evt)
//

bool ResetBookmarks()
{
	tFile * tf;
	TYPE_File * file;
	word  k,bm;
	dword *pbm;

	bm = 0x578;										//DVB-S
	if (sysID == 10446 || sysID == 12406) bm-=4;	//DVB-C
	tf = DSGetNextFile();
	if (tf == NULL) return FALSE;
	file = DSOpenFile(tf);
	if (file != NULL) {
		TAP_Hdd_Fread(buffer, 1656, 1, file);
		pbm = (dword *)(buffer+bm);
		for (k=0; k<64; k++) *pbm++ = 0;
		TAP_Hdd_Fseek(file, 0, SEEK_SET);
		TAP_Hdd_Fwrite(buffer, 1656, 1, file);
		TAP_Hdd_Fclose(file);
	}
	return TRUE;
}

//
// Bei einem Werbeblock mit einem 5.1 Werbespot werden die drei Teile
// zu einem groen Werbeblock zusammengelegt. [2.0 + 5.1 + 2.0]
//

void OverlapTest()
{
	int k,n;
	for (k=0; k<werbung.count-1; k++) {
		if (werbung.ende[k] >= werbung.start[k+1]) {	//WB Overlap
			if (ini.bBlackbox) LogFileInt("Overlap %d", k);
			if (werbung.start[k+1] < werbung.start[k])
				werbung.start[k] = werbung.start[k+1];
			if (werbung.ende[k+1] > werbung.ende[k])
				werbung.ende[k] = werbung.ende[k+1];
			for (n=k+1; n<werbung.count-1; n++) {
				werbung.start[n] = werbung.start[n+1];
				werbung.ende[n] = werbung.ende[n+1];
			}
			werbung.count--;
		}
	}
	if (ini.bBlackbox) LogFileInt("Werbeblcke %d", werbung.count);
}

//
// Den eigentlichen Werbeblock-Start suchen (bei 5.1 Werbespots)
//

dword WerbeblockStart( dword blocks )
{
	int k;
	word mode;
	dword offset,left,right,step;
	k = 0;
	left = right = blocks;
	step = TEST_BLOCKS;
	do {
		left -= step;
		Hdd_Fseek(left*188);	// 1 block = 188 sectors
		mode = PidsFindArea51();
	} while (mode == 0x20 && left > step && ++k < 10);
	if (mode == 0x20 || left < step) return 0;
	k = 0;
	do {
		offset = (left+right)>>1;
		Hdd_Fseek(offset*188);
		mode = PidsFindArea51();
		if (mode == 0x51)
			left = offset;
		else
			right = offset;
		step >>= 1;
	} while (mode != 0 && step > 5);
	return offset;
}

//
// Das eigentliche Werbeblock-Ende suchen (bei 5.1 Werbespots)
//

dword WerbeblockEnde( dword blocks )
{
	int k;
	word mode;
	dword offset,left,right,step;
	k = 0;
	left = right = blocks;
	step = TEST_BLOCKS;
	do {
		right += step;
		Hdd_Fseek(right*188);
		mode = PidsFindArea51();
	} while (mode == 0x20 && right < patch.totalBlocks && ++k < 10);
	if (mode == 0x20 || right > patch.totalBlocks) return 0;
	k = 0;
	do {
		offset = (left+right)>>1;
		Hdd_Fseek(offset*188);
		mode = PidsFindArea51();
		if (mode == 0x20)
			left = offset;
		else
			right = offset;
		step >>= 1;
	} while (mode != 0 && step > 5);
	return offset;
}

//

bool WerbeblockTest()
{
	int k;
	bool ovrlp;
	word mode;
	dword offset,blocks;
	ovrlp = FALSE;
	k = 0;
	if (werbung.count == 0) return FALSE;
	while (k < werbung.count) {
		if (werbung.start[k] > TEST_BLOCKS) {
			offset = (werbung.start[k]-TEST_BLOCKS)*188;
			Hdd_Fseek(offset);
			mode = PidsFindArea51();
			if (mode == 0x20) {
				blocks = WerbeblockStart(werbung.start[k]-TEST_BLOCKS);
				if (blocks > 0) {
					if (ini.bBlackbox) LogFileInt2("Move WB-Start %d -> %d", werbung.start[k], blocks);
					werbung.start[k] = blocks; ovrlp=TRUE;
				}
			}
		}
		if (werbung.ende[k] < patch.totalBlocks) {
			offset = (werbung.ende[k]+TEST_BLOCKS)*188;
			Hdd_Fseek(offset);
			mode = PidsFindArea51();
			if (mode == 0x20) {
				blocks = WerbeblockEnde(werbung.ende[k]+TEST_BLOCKS);
				if (blocks > 0) {
					if (ini.bBlackbox) LogFileInt2("Move WB-Ende %d -> %d", werbung.ende[k], blocks);
					werbung.ende[k] = blocks; ovrlp=TRUE;
				}
			}
		}
		k++;
	}
	if (ovrlp) OverlapTest();
	return TRUE;
}

//

int InitAdvertising()
{
	word  k;
	werbung.count = 0;
	if (patch.blockCount == 0) return 0;
	k = 0;
	// Werbung am Anfang der Aufnahme oder Vorlauf
	if (patch.startMode == 0x20 && patch.modes[0] == 0x51) {
		werbung.start[0] = 0;
		werbung.ende[0] = patch.blocks[0];
		werbung.count++;
		k++;
	}
	if (patch.blockCount == 1) return 0;
	// Werbung im Film
	while (k < patch.blockCount-1) {
		if (patch.modes[k] == 0x20 && patch.modes[k+1] == 0x51) {
			werbung.start[werbung.count] = patch.blocks[k];
			werbung.ende[werbung.count]  = patch.blocks[k+1];
			werbung.count++;
			k+=2;
		} else
			k++;
	}
	//Werbung am Ende der Aufnahme (Start vor 4GB, Ende nach 4GB)
	if (k == patch.blockCount-1 && patch.modes[k] == 0x20) {
		werbung.start[werbung.count] = patch.blocks[k];
		werbung.ende[werbung.count]  = 0xFFFFFFFF;
		werbung.count++;
	}
	return 0;
}

//
// Bookmarks bei Filmstart und bei Start/Ende der Werbeblocke einfgen
//

void InitBookmarks()
{
	int i,k;
	k=0;
	for (i=0; i<werbung.count; i++) {
		if (ini.bBookmarkS && k < MAX_BOOKMARKS && werbung.start[i] > 0)
			bookmarks.position[k++] = werbung.start[i];
		if (ini.bBookmarkE && k < MAX_BOOKMARKS && werbung.ende[i] < 0xFFFFFFFF)
			bookmarks.position[k++] = werbung.ende[i] + ini.dejavue;
	}
	if (ini.bBlackbox) LogFileInt("InitBookmarks %d", k);
	bookmarks.count = k;
}

bool PatchBookmarks()
{
	word  k,bm;
	dword *pbm;

	bm = 0x578;										//DVB-S
	if (sysID == 10446 || sysID == 12406) bm-=4;	//DVB-C
	pbm = (dword *)(buffer+bm);
	if (*pbm > 0 && *pbm < patch.totalBlocks) {
		if (ini.bBlackbox) LogFileText("Bookmarks nicht berschreiben");
		return FALSE;	// Film hat schon Bookmarks
	}
	InitBookmarks();
	if (bookmarks.count == 0) return FALSE;
	for (k=0; k<bookmarks.count; k++) {
		*pbm++ = bookmarks.position[k];
		if (ini.bBlackbox) LogFileInt("Bookmark = %d", bookmarks.position[k]);
	}
	*pbm = 0;
	patch.patched = TRUE;
	return TRUE;
}

bool ImportBookmarks()
{
	int   k,bm,count;
	bool  bnew;
	dword *pbm;
	tFilm * pFilm;
	TYPE_File * file;

	if (!ini.bFilmList) return FALSE;
	if (FilmListExists(pFile) < 0) {
		FilmListAddFilm(pFile);
		bnew = TRUE;
	} else bnew = FALSE;
	pFilm = FilmListGet();
	if (pFilm->werbeBlock[0].ende != 0xFFFFFFFF) return FALSE;
	file = DSOpenFile(pFile);
	if (file == NULL) {
		if (ini.bBlackbox) LogFileText("kein Zugriff");
		if (bnew) FilmListDel();
		return FALSE;
	}
	TAP_Hdd_Fread(buffer, 1656, 1, file);
	TAP_Hdd_Fclose(file);
	bm = 0x578;										//DVB-S
	if (sysID == 10446 || sysID == 12406) bm-=4;	//DVB-C
	pbm = (dword *)(buffer+bm);
	bookmarks.count = 0;
	while (*pbm > 0 && *pbm < patch.totalBlocks && bookmarks.count < MAX_BOOKMARKS) {
		bookmarks.position[bookmarks.count++] = *pbm++;
	}
	if (bookmarks.count >= 4 && (bookmarks.count & 1) == 0) {
		if (bookmarks.position[1]-bookmarks.position[0] > 4500) return FALSE;
		if (bookmarks.position[3]-bookmarks.position[2] > 4500) return FALSE;
		count = bookmarks.count >> 1;
		bm = 0;
		for (k=0; k<count; k++) {
			pFilm->werbeBlock[k].start = bookmarks.position[bm++];
			pFilm->werbeBlock[k].ende  = bookmarks.position[bm++];
		}
		if (ini.bBlackbox) {
			LogFileDateTime(pFile->name);
			LogFileInt("BM Import %d", bookmarks.count);
		}
		return TRUE;
	}
	if (bnew) FilmListDel();
	return FALSE;
}

//
// Position der Werbeblcke merken
//

int MakeFilmList()
{
	int i;

	FilmListAddFilm(pFile);
	for (i=0; i<werbung.count; i++) {
		FilmListAddBlock(werbung.start[i], werbung.ende[i]);
		if (ini.bBlackbox)
			LogFilePercent("Werbung =", werbung.start[i], werbung.ende[i], patch.totalBlocks);
	}
	return 0;
}

//

void PatchExtEPG()
{
	int  epgPos,tempLen;
	word *pEpgLen;
	char *ende;
	char mode[8];
	char temp[32];

	epgPos = 0x170;
	if (sysID == 10446 || sysID == 12406) epgPos-=4;	//DVB-C
	pEpgLen = (word *)(buffer+epgPos-6);
	if (*pEpgLen < 992) {
		mode[0] = 0;
		if (patch.ac3Mode == 0x20) strcpy(mode, "\nDD 2.0");
		if (patch.ac3Mode == 0x51) strcpy(mode, "\nDD 5.1");
		strcpy(temp, "\n\nOverfly was here :-)");
		tempLen = strlen(temp);
		if (*pEpgLen < tempLen || strstr(buffer+epgPos, temp) == NULL) {
			ende = buffer+epgPos+(*pEpgLen);
			strcpy(ende, temp);
			*pEpgLen += tempLen;
			if (mode[0] != 0) {
				ende += tempLen;
				strcpy(ende, mode);
				*pEpgLen += 7;
			}
			patch.patched = TRUE;
		}
	}
}

//

bool RenameFile()
{
	int  i,k,len;
	byte ch;
	bool b;
	char temp[10];

	if (ini.bBlackbox) {
		LogFileText("RenameFile");
		LogFileText(patch.oldName);
	}
	len = strlen(patch.oldName);
	if (len < 5 || len > TS_FILE_NAME_SIZE-7) {
		return FALSE;
	}
	if (strncmp(patch.oldName, "Of_", 3) == 0) {
		return FALSE;
	}
	strcpy(patch.newName, "Of_");
	strcpy(patch.newName+3, patch.oldName);
	len += 3;
	k=0;
	for (i=0; i<len; i++) {
		ch = patch.newName[i];
		switch (ch) {
			case '\\': ch='-'; break;
			case '/' : ch='-'; break;
			case ':' : ch=';'; break;
			case '*' : ch='+'; break;
			case '?' : ch='.'; break;
			case '\"': ch='-'; break;
			case '<' : ch='-'; break;
			case '>' : ch='-'; break;
			case '|' : ch='-'; break;
			case '' : ch='a'; break;
		}
		patch.newName[k++] = ch;
		if (ch > 0 && ch < 32) k--;
	}
	patch.newName[k] = 0;
	len = k;
	if (ini.bBlackbox) LogFileText(patch.newName);
	i=1;
	while (TAP_Hdd_Exist(patch.newName) && ++i < 32) {
		TAP_SPrint(temp, "-%d.rec", i);
		strcpy(patch.newName+len-4, temp);
	}
	if (i == 32) return FALSE;
	b = TAP_Hdd_Rename( patch.oldName, patch.newName);
	if (ini.bBlackbox) LogFileInt("Rename? %d", b);
	if (!b) {
		TAP_Delay(50);
		b = TAP_Hdd_Rename( patch.oldName, patch.newName);
		if (ini.bBlackbox) LogFileInt("Rename? %d", b);
	}
	return b;
}

//

int PatchFinish()
{
	int len;
	if (patch.ac3Mode == 0x51) {
		InitAdvertising();
		WerbeblockTest();
	}
	if (ini.bBookmarkS || ini.bBookmarkE) PatchBookmarks();
	if (ini.bFilmList) MakeFilmList();
	if (ini.bPatchEPG && ((patch.ac3Mode == 0x51 && patch.blockCount > 2) ||
		(patch.letterbox && werbung.count > 0))) PatchExtEPG();
	if (patch.patched) {
		TAP_Hdd_Fseek(patch.file, 0, SEEK_SET);
		TAP_Hdd_Fwrite(buffer, 1656, 1, patch.file);
	}
	TAP_Hdd_Fclose(patch.file);
	if (ini.bBlackbox) {
		LogFileInt("Letterbox %d", patch.letterbox);
		LogFileInt("Werbung %d", werbung.count);
	}
	return 0;
}

//

bool IsVisibleOSD()
{
	int x,y;
	word * pw;
	TYPE_OsdBaseInfo osdBaseInfo;
	TAP_Osd_GetBaseInfo( &osdBaseInfo );
	pw = osdBaseInfo.eAddr+(720*288)+360;
	for (x=180; x<540; x+=10) {
		if (*pw != 0) return TRUE;
		pw+=10;
	}
	pw = osdBaseInfo.eAddr+(720*20)+720;
	for (y=10; y<278; y+=5) {
		if (*pw != 0) return TRUE;
		pw+=3600;
	}
	return FALSE;
}

//
/*
void MessageBox( char * msg )
{
	word rgn;
	int x,y,w,h;
	x=w=240; h=44;
	y=(576-h)>>1;
	rgn=0;
	osdBoxData = TAP_Osd_SaveBox(rgn, x, y, w, h);
	TAP_Osd_FillBox(rgn, x, y, w, h, RGB(2,7,10));
	TAP_Osd_PutS(rgn, x+10, y+((h-22)>>1), x+w-10, msg, RGB(27,29,30),
		COLOR_None, 0, FNT_Size_1622, 0, ALIGN_CENTER);
	TAP_Delay(100);
	if (osdBoxData != NULL) {
		TAP_Osd_RestoreBox(rgn, x, y, w, h, osdBoxData);
		TAP_MemFree(osdBoxData);
		osdBoxData = NULL;
	}
}
*/
//

void DeleteFilmList()
{
	ChangeToRoot();
	TAP_Hdd_ChangeDir("ProgramFiles");
	if (TAP_Hdd_Exist(FILM_LIST_FILE))
		TAP_Hdd_Delete(FILM_LIST_FILE);
}

void UpdateFilmList()
{
	bFindFiles = bNextStep = TRUE;
	FilmListRead();
}

//

void VolumeMinus()
{
	int v;
	if (bVolume || ini.volume == 0) return;
	currVolume = TAP_GetSystemVar(SYSVAR_Vol);
	if ((currVolume & 128) == 128) return; //Mute
	v = currVolume-ini.volume;
	if (v < 0) v=0;
	TAP_SetSystemVar(SYSVAR_Vol, v);
	bVolume = TRUE;
}

void VolumePlus()
{
	if (ini.volume == 0) return;
	if (bVolume) {
		TAP_SetSystemVar(SYSVAR_Vol, currVolume);
		bVolume = FALSE;
	}
}

//
// Letterbox Test fr den Zeitraum von AC3-Format Umschaltung bis zum Start
// der Werbung. Das sind normalerweise 1-4 Sekunden vor einem Werbeblock.
// Speed Optimized: Testdauer < 0.01 Sek.
//

int ScanPicture()
{
	volatile dword *WMIF_ATBL0_Y = (dword *) 0xB0010040;
	byte  *picAddr;
	byte  *pos;
	int   x,y,z,line,pixel;

	picAddr = (byte *) (((*WMIF_ATBL0_Y & 0xffff0000) >> 6) | 0xA0000000) + (5<<10);
	y = line = 8;
	z = pixel = 0;
	do {										//8*32-8 Zeilen
		do {
			pos = picAddr+z+(y<<5);				//80 Pixel pro Zeile
			for (x=0; x<16; x++) {				//x=160..190
				if (*pos > 20) pixel++;
				pos+=2;
			}
			pos += 992;
			for (x=0; x<16; x++) {				//x=192..222
				if (*pos > 20) pixel++;
				pos+=2;
			}
			pos += 992;
			for (x=0; x<16; x++) {				//x=224..254
				if (*pos > 20) pixel++;
				pos+=2;
			}
			pos += 992;
			for (x=0; x<16; x++) {				//x=256..286
				if (*pos > 20) pixel++;
				pos+=2;
			}
			pos += 992;
			for (x=0; x<16; x++) {				//x=288..318
				if (*pos > 20) pixel++;
				pos+=2;
			}
			if (pixel > 32) return line;		//>32 helle Pixel
			line++;
			y++;
		} while (y < 32);
		y = 0;
		z += (736<<5);
	} while (z < (736<<8));
	return line;	//256
}

//

bool rECo_test( byte slot )
{
	if (!TAP_Hdd_GetRecInfo(slot, &recInfo))
		return FALSE;
	if (recInfo.recType == RECTYPE_Normal && recInfo.svcType == SVC_TYPE_Tv)
		return TRUE;
	return FALSE;
}

void DataFilesReloaded()
{
	int rECoCount;
	rECoCount = 0;
	if (rECo_test(0)) rECoCount++;
	if (rECo_test(1)) rECoCount++;
	if (rECoCount < rECo && rECoCount == 0)		//Aufnahme wurde beendet
		UpdateFilmList();						//--> sofort suchen und patchen!
	rECo = rECoCount;
}

//

void TSRCommanderConfigDialog()
{
	if (!bNextStep)
		DialogOpen("Overfly Einstellungen", &ini);
	else
		DialogOpenScan("Overfly");
	bDialog = TRUE;
	return;
}

bool TSRCommanderExitTAP(void)
{	
	return TRUE;
}

//
// ein kleiner Schritt pro IdleEvent
//

int NextStep()
{
	int pid;
	switch (patch.nextStep) {
		case 0:						// Next File
			pFile = DSGetNextFile();
			if (pFile == NULL)
				return -1;			// habe fertig!
			memset(&patch, 0, sizeof(tPatch));
			bookmarks.count = 0;
			werbung.count = 0;
			DrawCountdown(countdown--);
			if (ini.bBMImport)
				if (ImportBookmarks()) {
					patch.nextStep = 0;
					return 0;
				}
			pid = GetAC3Pid();
			if (pid < 0) patch.nextStep = -1;
			else if (ini.bLetterbox) {
				if (pid == 0) patch.nextStep = 2;
				LetterboxInit();
			}
			break;
		case 1:
			GetAC3Mode(TS_START);	// Anfang
			GetAC3Mode(256<<20);	// 256 MB
			break;
		case 2:
			GetAC3Mode(512<<20);	// 512 MB
			GetAC3Mode(768<<20);	// 768 MB
			PatchAudioPid();
			break;
		case 3:
			if (patch.ac3Mode < 0x51 && ini.bLetterbox) {
				if (LetterboxTest() == 2) patch.nextStep--;	//nochmal
			} else patch.letterbox = FALSE;
			break;
	}
	if (patch.nextStep == 0x100000) {
		PatchFinish();
		patch.nextStep++;
		return 0;
	}
	if (patch.nextStep == 0x100001) {
		if (ini.bRename && ((patch.ac3Mode == 0x51 && patch.blockCount > 2) ||
			(patch.letterbox && werbung.count > 0))) RenameFile();
		patch.nextStep = 0;
		return 0;
	}
	if (patch.nextStep >= 4) {
		if (ini.bBookmarkS || ini.bBookmarkE || ini.bFilmList) {
			if (patch.ac3Mode == 0x51) {
				if (FilmFinder() == 0) patch.eof = TRUE;
				DrawCountdown(countdown+1);
			} else {
				if (patch.letterbox) {
					if (LetterboxFinder() == 0) patch.eof = TRUE;
					DrawCountdown(countdown+1);
				} else patch.eof = TRUE;
			}
		} else
			patch.eof = TRUE;
		if (patch.eof) {
			patch.nextStep = 0x100000;
			return 0;
		}
	}
	patch.nextStep++;
	return 0;
}

//
// liefert 2 wenn die Men Taste 2x schnell gedrckt wurde (0.8 Sek.)
//

dword MenuKey( dword key )
{
	dword tick;
	if (key == ini.menuKey) {
		if (key == RKEY_Exit) return 2;
		tick = TAP_GetTick();
		if (menuKeyCount == 0 || tick-menuKeyTicks > 80) {
			menuKeyCount = 1;
			menuKeyTicks = tick;
			return 0;
		} else {
			menuKeyCount = 2;
			menuKeyTicks = tick;
			return 2;
		}
	} else
		menuKeyCount = 0;
	return key;
}

//
// berflieger fr Werbeblcke
//

int Aviator()
{
	int idx,wb,lbox;
	dword fdt,start,ende,diff,distance;
	if (!TAP_Hdd_GetPlayInfo( &playInfo[0] ))
		return -1;
	if (playInfo[0].currentBlock == 0 || playInfo[0].currentBlock == 0xFFFFFFFF ||
		playInfo[0].totalBlock == 0)
		return -2;
	if (playInfo[0].playMode != PLAYMODE_Playing || playInfo[0].trickMode != TRICKMODE_Normal)
		return -3;
	if (playInfo[0].file == NULL)
		return -4;
	fdt = (playInfo[0].file->mjd <<16) | (playInfo[0].file->hour <<8) | playInfo[0].file->min;
	if ((idx = FilmListFind(playInfo[0].file->startCluster, fdt)) < 0)
		return -5;
	wb = 0;
	do {
		start = newFilmList[idx].werbeBlock[wb].start;
		ende = newFilmList[idx].werbeBlock[wb].ende;
		distance = ende-start;
		diff = playInfo[0].currentBlock - start;
		if (diff < 70 && distance < 7000) {	// Start eines Werbeblocks
			if (start > 0) VolumeMinus();
			lbox = ScanPicture();
			if (diff < ini.jumpDelay && lbox >= 32) return 2;	//Letterbox
			if (diff >= ini.jumpDelay || lbox < 32) {
				if (ende != 0xFFFFFFFF) {	// Werbeblock berspringen
					if (start > 0) ende += ini.dejavue;
					TAP_Hdd_ChangePlaybackPos(ende);
					VolumePlus();
					return 1;
				} else VolumePlus();
			}
		}
		wb++;
	} while (start != 0xFFFFFFFF && wb < MAX_WERBEBLOCK);
	return 0;
}

//

void InitTAP()
{
	sysID = *((volatile word*)0xA3FFFFFA);
	bFindFiles = bNextStep = FALSE;
	bVolume = bDialog = bIniFile = FALSE;
	bResetAudioPids = bResetBookmarks = FALSE;
	rECo = 0;
	menuKeyCount = menuKeyTicks = 0;
	memset(&patch, 0, sizeof(tPatch));
	if (ReadIniFile() == 0) {
		bIniFile = bFindFiles = bNextStep = TRUE;
	}
	if (ini.bFilmList) FilmListRead();
	if (ini.bPatchFseek)
		ini.bPatchFseek = FileSeekPatch(TRUE);
	LogFileDelete();
	idleTick = startTick = TAP_GetTick();
	if (idleTick < 6000 && bIniFile)
		idleTick += (ini.autoStart*100);	//Autostart Delay
	bInitialized = TRUE;
}

//

dword TAP_EventHandler( word event, dword param1, dword param2 )
{
	dword tick,rc,mainState,subState;
	int avi;
	static bool bIgnoreKey = FALSE;

	if (!bInitialized) {
		InitTAP();
	}
	if (event == EVT_KEY) {
		if (bDialog) {
			switch (DialogKey(param1)) {
				case MENU_NONE:
					break;
				case MENU_SAVE:
					WriteIniFile();
					break;
				case MENU_DELETE:
					WriteIniFile();
					DeleteFilmList();
					break;
				case MENU_UPDATE:
					WriteIniFile();
					UpdateFilmList();
					break;
				case MENU_BOOKMARK:
					WriteIniFile();
					DSFindFiles(FALSE);
					bResetBookmarks = TRUE;
					break;
				case MENU_AUDIO:
					WriteIniFile();
					DSFindFiles(FALSE);
					bResetAudioPids = TRUE;
					break;
				case MENU_NEXTTAP:
					return RKEY_Exit;
				case MENU_EXIT:
					TSRCommander.ExitTAP = TRUE;
					break;
				case MENU_CANCEL:
					if (bNextStep && !bFindFiles) {
						bNextStep = FALSE;
						if (ini.bBlackbox) LogFileSave();
						DrawCountdown(0);
						PidsFreeArea51();
						if (ini.bLetterbox) PidsFreeSlice();
						if (patch.file) TAP_Hdd_Fclose(patch.file);
					}
					break;
			}
			return 0;
		} else {
			if (bIgnoreKey) {	//generierten Men-Taste Event ignorieren
				bIgnoreKey = FALSE;
				return param1;
			}
			if (param1 == ini.menuKey) {
				TAP_GetState(&mainState, &subState);
			    if (mainState != STATE_Normal)
			        return param1;
				if (subState == SUBSTATE_Audio || subState == SUBSTATE_PipList ||
					subState == SUBSTATE_FavChListMenu)
					return param1;
				if (!IsVisibleOSD()) {
					rc = MenuKey(param1);
					if (rc == 2) {
						TSRCommanderConfigDialog();
						return 0;
					} else
						return rc;
				}
			}
			return param1;
		}
	}
	if (event != EVT_IDLE) return param1;
	tick = TAP_GetTick();
	if (menuKeyCount == 1 && tick-menuKeyTicks > 80) {	//Men-Taste Event generieren
		menuKeyCount = 0;
		bIgnoreKey = TRUE;
		TAP_GenerateEvent(EVT_KEY, ini.menuKey, 0);
		return 0;
	}
	if (tick < idleTick) return 0;
	if (bFindFiles) {
		PidsAllocArea51();
		if (ini.bLetterbox) {
			if (PidsAllocSlice() == NULL) ini.bLetterbox = FALSE;
		}
		if (ini.bBlackbox) {
			if (LogFileInit() < 0) ini.bBlackbox = FALSE;
		}
		countdown = DSFindFiles(ini.bSubdirs);
		if (ini.bTurbolader) Hdd_Init();
		bFindFiles = FALSE;
	}
	// pro Idle-Event nur ein NextStep()
	if (bNextStep) {
		if (NextStep() < 0) {
			bNextStep = FALSE;
			if (ini.bFilmList) FilmListWrite();
			if (ini.bBlackbox) LogFileSave();
			DrawCountdown(0);
			PidsFreeArea51();
			if (ini.bLetterbox) PidsFreeSlice();
		}
		idleTick = TAP_GetTick()+4;
	} else {
		if (!ini.bAviator || !ini.bFilmList) {
			if (!bDialog && tick > startTick+12000)
				TSRCommander.ExitTAP = TRUE;
			idleTick = TAP_GetTick()+1000;
		}
	}
	if (ini.bAviator && !bNextStep) {
		avi = Aviator();
		if (avi == 0)
			idleTick = TAP_GetTick()+100;	//5.1 Film luft
		else if (avi == 1)
			idleTick = TAP_GetTick()+700;	//Jump
		else if (avi == 2)
			idleTick = TAP_GetTick()+10;	//Letterbox Test
		else
			idleTick = TAP_GetTick()+400;	//keine 5.1 Wiedergabe
		if (ini.bFilmList && ini.bReload && !bDialog)
			DataFilesReloaded();
	}
	if (bResetBookmarks) {
		bResetBookmarks = ResetBookmarks();
		idleTick = TAP_GetTick()+10;
	}
	if (bResetAudioPids) {
		bResetAudioPids = ResetAudioPids();
		idleTick = TAP_GetTick()+10;
	}
	TSRCommanderWork();
	return 0;
}

//

int TAP_Main(void)
{
	bInitialized = FALSE;
	TSRCommanderInit(0, TRUE);
	return 1;
}

